﻿Imports System.Drawing
Imports Microsoft.Office.Core

Public Class Tickmarks

    Private Sub ThisAddIn_Startup() Handles Me.Startup

    End Sub

    Private Sub ThisAddIn_Shutdown() Handles Me.Shutdown

    End Sub

    Protected Overrides Function CreateRibbonExtensibilityObject() As Microsoft.Office.Core.IRibbonExtensibility
        Return New TmRibbon()
    End Function

    Public Sub DoIt(pic)
        Dim rng As Excel.Range
        Dim shp As Excel.Shape
        Dim lastShp As Excel.Shape
        System.Windows.Forms.Clipboard.SetImage(pic)
        rng = Application.Selection
        Application.ActiveSheet.Paste
        If pic.Height > Application.ActiveCell.Height Then
            With Application.Selection
                .Width = Application.ActiveCell.Height
                .Height = Application.ActiveCell.Height
            End With
        End If
        If Application.ActiveCell.Height > Application.ActiveCell.Width And pic.Width > Application.ActiveCell.Width Then
            With Application.Selection
                .Width = Application.ActiveCell.Width
                .Height = Application.ActiveCell.Width
            End With
        End If
        With Application.Selection
            .Name = "tm-" & .Name
            .Left = .Left + 1
            .Top = .Top + 1
            .Width = If(.Width >= 12.25, 12.25, .Width - 1)
            .Height = If(.Height >= 12.25, 12.25, .Height - 1)
        End With
        lastShp = Nothing
        ' Find rightmost shape
        For Each shp In Application.ActiveSheet.Shapes
            If shp.Name <> Application.Selection.name And shp.TopLeftCell.Address = rng.Address Then
                lastShp = shp
            End If
        Next

        If lastShp IsNot Nothing Then
            Application.Selection.Left = lastShp.Left + lastShp.Width
        End If

        rng.Select()
    End Sub

    Public Sub DeleteAllTickmarks()
        Dim shp As Excel.Shape
        If MsgBox("Are you sure you want to delete all tickmarks?", vbYesNo) = vbNo Then
            Exit Sub
        End If
        For Each shp In Application.ActiveSheet.Shapes
            If Left(shp.Name, 3) = "tm-" Then
                shp.Delete()
            End If
        Next
    End Sub
End Class
